//+------------------------------------------------------------------+
//|                                                  Dual MA.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//settings are for a EUR-USD, Renko-10
extern double MAHighpd     =5;
extern double MALowpd      =5;
extern double Lots         = 0.1;
extern double TakeProfit   = 0;
extern double TrailingStop = 10;
extern double StopLoss     = 0;

double StopLossLevel, TakeProfitLevel;
datetime      timeprev=0;
double pointvalue;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
   {
      if (Digits == 4 || Digits == 2) pointvalue = Point;
      else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
     //      if (EachTickMode) Current = 0; else Current = Current;

      return(0);
   }

int start()
  {
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   /*if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }*/
// to simplify the coding and speed up access
// data are put into internal variables
   double MaHC, MaLC, MaHP, MaLP;
   
   MaHC=iMA(NULL,0,MAHighpd,0,MODE_SMMA,PRICE_HIGH,0);
   MaLC=iMA(NULL,0,MALowpd,0,MODE_SMMA,PRICE_LOW,0);
   MaHP=iMA(NULL,0,MAHighpd,0,MODE_SMMA,PRICE_HIGH,1);
   MaLP=iMA(NULL,0,MALowpd,0,MODE_SMMA,PRICE_LOW,1);
   
   
   total=OrdersTotal();
   if(total<1) 
   {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
       
      if (StopLoss>0) StopLossLevel = Ask - StopLoss * pointvalue; else StopLossLevel = 0.0;          //Both WORKED for Buys only
      if (TakeProfit>0) TakeProfitLevel = Ask + TakeProfit * pointvalue; else TakeProfitLevel = 0.0;
           
      // check for long position (BUY) possibility 
      if(Close[0] >MaHC && Open[0] >MaHC && Close[1] <MaHP || Open[1] <MaHP)
       {
        ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"Renko Dual ma",16384,0,Green);
         if(ticket>0)
         {
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           {
            OrderModify(ticket,OrderOpenPrice(),StopLossLevel,TakeProfitLevel,0,DarkRed);
            //OrderModify(ticket,OrderOpenPrice(),Ask+TakeProfit*pointvalue,0,DarkRed); 
             Print("BUY order opened : ", OrderOpenPrice());
           }
          }
           else Print("Error opening BUY order : ",GetLastError()); 
           return(0); 
         }
     // check for short position (SELL) possibility 
      if (Close[0] <MaLC && Open[0] <MaLC && Close[1] >MaLP || Open[1] >MaLP)  
       { 
        ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"macd sample",16384,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           {  
            OrderModify(ticket,OrderOpenPrice(),StopLossLevel,TakeProfitLevel,0,DarkRed);
            //OrderModify(ticket,OrderOpenPrice(),Bid-TakeProfit*pointvalue,0,DarkRed);
            Print("SELL order opened : ", OrderOpenPrice());
           }
          } 
           else Print("Error opening SELL order : ",GetLastError()); 
           return(0); 
         }
      return(0);
     }
    // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Close[0] <MaHC && Close[1] >MaHP)        
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop L125
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>pointvalue*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-pointvalue*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-pointvalue*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
        else // go to short position
           {
            // should it be closed?
            if(Close[0] >MaHC && Close[1] <MaHP)// ||Close [0] > Close[1]        //if(MacdCurrent<0 && MacdCurrent>SignalCurrent &&
                                                      // MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*pointvalue))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(pointvalue*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+pointvalue*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+pointvalue*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.

